/*************************************************************************
 *
 * IPAT Interferometer threshold curve plotting utility
 * v2.3 7/30/96
 *
 *************************************************************************
 * Original header:
 *
 * Copyright -C- 1981 Kenneth H. Keller, Giles C. Billingsley
 *
 *     KIC is a graphics editor that was developed by the integrated
 * circuits group of the Electronics Research Laboratory and the
 * Department of Electrical Engineering and Computer Sciences at
 * the University of California, Berkeley, California.  The program
 * KIC is available free of charge to any interested party.
 * The sale, resale, or use of this program for profit without the
 * express written consent of the Department of Electrical Engineering
 * and Computer Sciences, University of California, Berkeley, California,
 * is forbidden.
 *
 *************************************************************************/
 
/*
 * Frame Buffer Desc;
 */

struct f {
    char *fDisplay;             /* display name */
    int fInterface;             /* index of graphics interface */
    int *fButtonMask;           /* pointer to array of button masks */
    int fMaxX,fMaxY;            /* raster dimensions of viewport */
    int fFontHeight,fFontWidth; /* standard font size */
    int fNumRows;               /* maximum number of horizontal rows */
    int fMaxIntensity;          /* always set to 255 (normalized intensity) */
    int fMaxP;                  /* maximum pixel intensity */
    int fNumColumns;            /* maximum number of vertical columns */
    int fNumColors;             /* maximum color index */
    int fNumFillPatterns;       /* maximum fill index */
    int fInitialized;           /* true if FB structure is initialized */
    int fNonDestructiveText;    /* true if text does not wipe background */
    int fLastCursorColumn;      /* last cursor column used by ShowPrompt() */
    int fFilledPolygons;        /* true if frame buffer has filled polygons */
    int fDefinableFillPatterns; /* true if fill styles are definable */
    int fButtons;               /* true if pointing device has buttons */
    int fNumButtons;            /* number of pointing device buttons */
    int fBlinkers;              /* true if layers can blink */
};

extern struct f FB;


struct sGinterface {
#ifdef __STDC__
    int  (*gInfo)(int);
    int  (*gOpen)(char*);
    int  (*gClose)(void);
    int  (*gUpdate)(void);
    void (*gPixel)(int,int);
    void (*gLine)(int,int,int,int);
    void (*gBox)(int,int,int,int);
/*    void (*gPolygon)(MFBPOLYGON*);  */
    void (*gPolygon)();
    int  (*gDefLs)(int,int);
    int  (*gSetLs)(int);
    int  (*gDefFp)(int,int*);
    int  (*gSetFp)(int);
    int  (*gDefColor)(int,int,int,int);
    int  (*gSetColor)(int);
    void (*gText)(char*,int,int,int);
    void (*gScText)(char*,int,int,int,int);
#else
    int  (*gInfo)();
    int  (*gOpen)();
    int  (*gClose)();
    int  (*gUpdate)();
    void (*gPixel)();
    void (*gLine)();
    void (*gBox)();
    void (*gPolygon)();
    int  (*gDefLs)();
    int  (*gSetLs)();
    int  (*gDefFp)();
    int  (*gSetFp)();
    int  (*gDefColor)();
    int  (*gSetColor)();
    void (*gText)();
    void (*gScText)();
#endif
};

#define FBNUMINTERFACE 2
extern struct sGinterface GR[FBNUMINTERFACE];

/* printer driver codes */
#define HPLASER 'h'
#define POSTSC  'p'


#define ERASE                  'e'
#define DISPLAY                'd'
#define FILL                   'f'
#define OUTLINE                'o'
#define ROW_COLUMN             'r'
#define PIXEL_COORDINATE       'p'

#define FBInfo                 (*GR[FB.fInterface].gInfo)
#define FBEnd                  (*GR[FB.fInterface].gClose)
#define FBTransfer             (*GR[FB.fInterface].gUpdate)
#define FBLine                 (*GR[FB.fInterface].gLine)
#define FBPixel                (*GR[FB.fInterface].gPixel)
#define FBDefineFillPattern    (*GR[FB.fInterface].gDefFp)
#define FBDefineLineStyle      (*GR[FB.fInterface].gDefLs)
#define FBBox                  (*GR[FB.fInterface].gBox)
#define FBSetFillPattern       (*GR[FB.fInterface].gSetFp)
#define FBSetLineStyle         (*GR[FB.fInterface].gSetLs)
#define FBDefineColor          (*GR[FB.fInterface].gDefColor)
#define FBSetColor             (*GR[FB.fInterface].gSetColor)
#define FBText                 (*GR[FB.fInterface].gText) 
#define FBScaledText           (*GR[FB.fInterface].gScText) 

#define FBUpdate               FBTransfer

#define FBSetTextClip          MFBSetTextClip
#define FBSetTextMode          MFBSetTextMode
#define FBBlink                MFBSetBlinker
#define FBFlood                MFBFlood
#define FBMore                 MFBMore
#define FBLineClip             MFBLineClip
#define FBTextBB               MFBTextBB
#define FBSetGhost             MFBSetGhost
#define FBSetALUMode           MFBSetALUMode
#define FBSetName              MFBSetName
#define FBSelectFont           MFBSelectFont
#define FBSelectCursor         MFBSelectCursor
#define FBSetCursorColor       MFBSetCursorColor
#define FBScrollList           MFBScrollList
#define FBScrollFont           MFBScrollFont
#define FBBeep                 MFBBeep
#define FBSetFullScreenCursor  MFBSetFullScreenCursor
#define FBResizeDrawingWindow  MFBResizeDrawingWindow
#define FBPoint                MFBPoint
